<template>
  <div id="header" class="header">
    <div class="top-header">
      <SearchBar
        class="search-bar"
        :searchResult="searchResult"
        @go-to-product-list="goToProductListFiltredByName"
        @search-product-while-tapping="searchSuggestion"
      />
      <UserCard
        class="user-card"
        :idActualUser="idActualUser"
        :role="role"
        @log-out-event="logOut"
      />
    </div>

    <NavBarComponent
      :idActualUser="idActualUser"
      :role="role"
      @show-login-page-event="showLogingPage"
      temporary
    />
  </div>
</template>

<script>
import NavBarComponent from './NavBarComponent.vue'
import SearchBar from './SearchBar.vue'
import UserCard from './UserCard.vue'
import API from '@/API.js'
export default {
  name: 'Header',
  components: {
    NavBarComponent,
    SearchBar,
    UserCard
  },
  props: {
    idActualUser: String,
    role: String
  },
  data() {
    return {
      // idActualUser: '',
      // role: '',
      searchResult: null,
      urlSearchProduct: '/api/search_product/',
      test: null
    }
  },
  mounted() {},
  methods: {
    async searchSuggestion(searchedWord) {
      this.searchResult = await API.searchProduct(searchedWord)
    },
    goToProductListFiltredByName(name) {
      //this.test = searchedWord;
      this.$router.push('/productList/searchedProductsByName/' + name)
    },
    showLogingPage() {
      this.$emit('show-login-page-event')
    },
    logOut() {
      this.$emit('log-out-event')
    }
  }
}
</script>

<style scoped>
.top-header {
  display: flex;
  justify-content: center;
  color: #747474;
}
.search-bar {
  width: 70%;
}
.user-card {
  width: 13%;
}
@media only screen and (max-width: 800px) {
  .top-header {
    flex-direction: column;
  }
  .user-card {
    width: auto;
  }
  .search-bar {
    width: auto;
  }
}
</style>
